program EnumUninstallEntry;

{$APPTYPE CONSOLE}

{$R 'version.res' 'version.rc'}

uses
  Windows,
  SysUtils,
  Classes,
  Registry;

//-----------------------------------------------------------------------------
//  OS̃o[W
type
    TOSVersionInfoEx = record
        dwOSVersionInfoSize : DWORD;
        dwMajorVersion      : DWORD;
        dwMinorVersion      : DWORD;
        dwBuildNumber       : DWORD;
        dwPlatformId        : DWORD;
        szCSDVersion        : array[0..127] of AnsiChar;
        wServicePackMajor   : WORD;
        wServicePackMinor   : WORD;
        wSuiteMask          : WORD;
        wProductType        : BYTE;
        wReserved           : BYTE;
    end;

//-----------------------------------------------------------------------------
// Windows.pas
function GetVersionEx(var lpVersionInformation: TOSVersionInfoEx): BOOL; stdcall; external kernel32 name 'GetVersionExA';

//-----------------------------------------------------------------------------
// http://www.geocities.jp/ht_deko/ft0203.html
// http://plaza5.mbn.or.jp/~heropa/vb25.htm
const
    VER_NT_WORKSTATION       = 1;
    VER_NT_DOMAIN_CONTROLLER = 2;
    VER_NT_SERVER            = 3;
    VER_SUITE_SMALLBUSINESS            = $0001;
    VER_SUITE_ENTERPRISE               = $0002;
    VER_SUITE_BACKOFFICE               = $0004;
    VER_SUITE_TERMINAL                 = $0010;
    VER_SUITE_SMALLBUSINESS_RESTRICTED = $0020;
    VER_SUITE_DATACENTER               = $0080;
    VER_SUITE_PERSONAL                 = $0200;
    VER_SUITE_BLADE                    = $0400;


//-----------------------------------------------------------------------------
//  蔲Ńo[W擾
function GetOsInfoEasy(): string;

    function PlatformId(ID: Cardinal): string;
    begin
        case ID of
            VER_PLATFORM_WIN32s			: Result := 'Windows 3.1';
            VER_PLATFORM_WIN32_WINDOWS	: Result := 'Windows 95';
            VER_PLATFORM_WIN32_NT		: Result := 'Windows NT';
        end;
    end;

var
    osi: TOSVersionInfo;
begin
    FillChar(osi, SizeOf(TOSVersionInfo), #0);
    osi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
    Windows.GetVersionEx(osi);
    Result := Format('%s Version %d.%d (Build %d : %s)',
            [PlatformId(osi.dwPlatformId),
            osi.dwMajorVersion,
            osi.dwMinorVersion,
            osi.dwBuildNumber,
            osi.szCSDVersion
        ]);
end;

//-----------------------------------------------------------------------------
//  {CŃo[W擾
function GetOsInfoHard(): string;
var
    osvi:TOSVersionInfoEx;
    res : Boolean;
    Key: HKEY;
    szProductType: string;
    dwBufLen, dwTemp: DWORD;
    lRet: integer;
begin
    Result := 'Unknown';

    // OSVERSIONINFOEX  GetVersionEx Ă݂ 
    // s OSVERSIONINFO łĂ݂ 

    // 
    FillChar(osvi, SizeOf(TOSVersionInfoEx), #0);

    // \̃TCYZbg
    osvi.dwOSVersionInfoSize := SizeOf(TOSVersionInfoEx);

    // Ă݂
    res := GetVersionEx(osvi);

    // s
    if not res then
    begin
        // ЂƂ̍\̂
        osvi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
        // ߂Ȃ炠߂
        if not GetVersionEx(osvi) then Exit;
    end;

    // dwPlatformId ŌɂȂقǏꍇ킯
    case osvi.dwPlatformId of

    // Windows NT n.
    VER_PLATFORM_WIN32_NT:
        begin

            // Ɠ肵Ă݂
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
            begin
                Result := 'Microsoft Windows .NET Server 2003 family, ';
            end else
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then
            begin
                Result := 'Microsoft Windows XP ';
            end else
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
            begin
                Result := 'Microsoft Windows 2000 ';
            end else
            begin
            if (osvi.dwMajorVersion <= 4) then
            begin
                Result := 'Microsoft Windows NT ';
            end else
                Result := 'Windows NT product family? ';
            end;

            // Windows NT 4.0 SP6 ȍ~Ɠ˂Œׂ.
            if res then
            begin

                // workstation ^Cv
                if (osvi.wProductType = VER_NT_WORKSTATION) then
                begin
                    if (osvi.dwMajorVersion = 4) then
                    begin
                        Result := Result + 'Workstation 4.0 ';
                    end else
                    if (osvi.wSuiteMask and VER_SUITE_PERSONAL) = VER_SUITE_PERSONAL then
                    begin
                        Result := Result + 'Home Edition ';
                    end else
                    begin
                        Result := Result + 'Professional ';
                    end;
                end else

                // server ^Cv
                if (osvi.wProductType = VER_NT_SERVER) then
                begin
                    if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER then
                        begin
                            Result := Result + 'Datacenter Edition ';
                        end else
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Enterprise Edition ';
                        end else
                        if (osvi.wSuiteMask = VER_SUITE_BLADE) then
                        begin
                            Result := Result + 'Web Edition ';
                        end else
                        begin
                            Result := Result + 'Standard Edition ';
                        end;
                    end else
                    if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER then
                        begin
                            Result := Result + 'Datacenter Server ';
                        end else
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Advanced Server ';
                        end else
                        begin
                            Result := Result + 'Server ';
                        end;
                    end else
                    // Windows NT 4.0
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Server 4.0, Enterprise Edition ';
                        end else
                        begin
                            Result := Result + 'Server 4.0 ';
                        end;
                    end;
                end;

            end else
            // Windows NT 4.0 SP5 ȑÔ
            begin
                lRet := RegOpenKeyEx(
                            HKEY_LOCAL_MACHINE,
                            'SYSTEM\CurrentControlSet\Control\ProductOptions',
                            0,
                            KEY_QUERY_VALUE,
                            Key
                        );
                if lRet <> ERROR_SUCCESS then Exit;

                dwBufLen := 255;
                szProductType := '';
                SetLength(szProductType, dwBufLen);

                lRet := RegQueryValueEx(
                            Key,
                            'ProductType',
                            nil,
                            nil,
                            @szProductType[1],
                            @dwBufLen
                        );
                if (lRet <> ERROR_SUCCESS) then Exit;
                dwTemp := Length(szProductType);
                if (dwBufLen > dwTemp) then Exit;
                SetLength(szProductType, dwBufLen);

                RegCloseKey(Key);

                if UpperCase(szProductType) = 'WINNT' then
                begin
                    Result := Result + 'Workstation ';
                end else
                if UpperCase(szProductType) = 'LANMANNT' then
                begin
                    Result := Result + 'Server ';
                end else
                if UpperCase(szProductType) = 'SERVERNT' then
                begin
                    Result := Result + 'Advanced Server ';
                end;

                Result := Result + Format('%d.%d', [osvi.dwMajorVersion, osvi.dwMinorVersion]);
            end;

            // T[rXpbNƂrhԍƂ

            if (osvi.dwMajorVersion = 4) and (lstrcmpi( osvi.szCSDVersion, 'Service Pack 6' ) = 0 ) then
            begin
                // SP6 ? SP6a?

                lRet := RegOpenKeyEx(
                            HKEY_LOCAL_MACHINE,
                            'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\Q246009',
                            0,
                            KEY_QUERY_VALUE,
                            Key
                        );
                if (lRet = ERROR_SUCCESS) then
                begin
                    Result := Result + Format('Service Pack 6a (Build %d)', [osvi.dwBuildNumber and $FFFF]);
                end else

                // Windows NT 4.0 prior to SP6a
                begin
                    Result := Result + Format('%s (Build %d)', [osvi.szCSDVersion, osvi.dwBuildNumber and $FFFF]);
                end;
                RegCloseKey(Key);
            end else

            // Windows NT 3.51 and earlier or Windows 2000 and later
            begin
                Result := Result + Format('%s (Build %d)', [osvi.szCSDVersion, osvi.dwBuildNumber and $FFFF]);
            end;

        end;

    // Windows 95 n.
    VER_PLATFORM_WIN32_WINDOWS:
        begin
            // win95
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 0) then
            begin
                Result := 'Microsoft Windows 95 ';
                if (osvi.szCSDVersion[1] = 'C') or (osvi.szCSDVersion[1] = 'B') then
                begin
                    Result := Result + 'OSR2 ';
                end;
            end else
            // win98
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 10) then
            begin
                Result := 'Microsoft Windows 98 ';
                if ( osvi.szCSDVersion[1] = 'A') then
                begin
                    Result := Result + 'SE ';
                end;
            end else
            // winme
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 90) then
            begin
                Result := 'Microsoft Windows Millennium Edition';
            end;
        end;

    // ȊO
    VER_PLATFORM_WIN32s:
        begin
            Result := 'Microsoft Win32s';
        end;

    end;

end;

//-----------------------------------------------------------------------------
//  Ăяop
function GetOsInfo(): string;
begin
    try
        Result := GetOsInfoHard();
    except
        try
            Result := GetOsInfoEasy();
        except
            Result := 'Microsoft Windows';
        end;
    end;
end;

//------------------------------------------------------------------------------
// o[W擾
//  http://www2.odn.ne.jp/~cag07740/tech_info/delphi_ans5.html
//  http://hp.vector.co.jp/authors/VA026252/tips/delphi_version.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0226.txt
function GetVersionInfo(const Request, Path: string): string;
const
    Translation = '\VarFileInfo\Translation';
    FileInfo = '\StringFileInfo\%0.4s%0.4s\';
var
    BufSize, HWnd: DWORD;
    VerInfoBuf: Pointer;
    VerData: Pointer;
    VerDataLen: Longword;
    PathLocale: String;
begin
    // Kvȃobt@̃TCY擾
    BufSize := GetFileVersionInfoSize(PChar(Path), HWnd);
    if BufSize <> 0 then
    begin
        // m
        GetMem(VerInfoBuf, BufSize);
        try
            GetFileVersionInfo(PChar(Path), 0, BufSize, VerInfoBuf);
            // ϐubN̕ϊe[uw
            VerQueryValue(VerInfoBuf, PChar(Translation), VerData, VerDataLen);
            if (VerDataLen > 0) then
            begin
                // 8̂PUiɕϊ
                // '\StringFileInfo\027382\FileDescription'
                PathLocale := Format(FileInfo + Request,
                                [IntToHex(Integer(VerData^) and $FFFF, 4),
                                IntToHex((Integer(VerData^) shr 16) and $FFFF, 4)]);
                VerQueryValue(VerInfoBuf, PChar(PathLocale), VerData, VerDataLen);
                if VerDataLen > 0 then
                begin
                    // VerData̓[ŏI镶ł͂ȂƂɒ
                    result := '';
                    SetLength(result, VerDataLen);
                    StrLCopy(PChar(result), VerData, VerDataLen);
                    Result := Trim(Result);
                end;
            end;
        finally
            // 
            FreeMem(VerInfoBuf);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  {
const
    KEY_HOTFIX = 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall';
var
    LRegistry: TRegistry;
    LEnumKeys: TStringList;
    i: Integer;
    LSubKey: String;
    LLine: String;
begin
    //  EXEo
    Writeln(GetVersionInfo('FileDescription', ParamStr(0)));
    Writeln(
        ExtractFileName(ParamStr(0))
        + ' ' + Format('Ver.%s', [GetVersionInfo('FileVersion', ParamStr(0))])
        );
    Writeln;

    //  OSo[Wo
    Writeln(StringReplace(GetOsInfo(), 'Microsoft ', '', []));
    Writeln;

    //  HotFixꗗo
    LRegistry := TRegistry.Create();
    LEnumKeys := TStringList.Create();
    try
        //  [gL[ݒ
        LRegistry.RootKey := HKEY_LOCAL_MACHINE;

        //  ǂݎpŊJ
        if (LRegistry.OpenKeyReadOnly(KEY_HOTFIX)) then
        begin
            try
                //  z̃L[
                LRegistry.GetKeyNames(LEnumKeys);
            finally
                //  WXg
                LRegistry.CloseKey();
            end;

            //  z̃L[ǂݏoꍇ
            for i := 0 to LEnumKeys.Count - 1 do
            begin
                //  L[̖̂o
                LSubKey := LEnumKeys.Strings[i];

                //  ߂ēǂݎpŊJ
                if (LRegistry.OpenKeyReadOnly(KEY_HOTFIX + '\' + LSubKey)) then
                begin
                    try
                        LLine := '[' + LSubKey + '] ' + LRegistry.ReadString('DisplayName');
                        //  R\[ɏo
                        WriteLn(LLine);
                    finally
                        //  
                        LRegistry.CloseKey();
                    end;
                end;
            end;
        end;

        Writeln;
        Writeln(Format('Found %d Hot-Fix', [LEnumKeys.Count]));

     finally
        LRegistry.Free();
        LEnumKeys.Free();
    end;

    //  ÎƂ߂
    //Readln;
end.
